Stepline Chart in JavaScript

Using ApexCharts with JavaScript

This Stepline Chart example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'Setpoint',
      data: [16, 16, 18, 21, 21, 19, 19, 22, 22, 18, 16],
    },
  ],
  chart: {
    type: 'line',
    height: 350,
  },
  stroke: {
    curve: 'stepline',
  },
  dataLabels: {
    enabled: false,
  },
  title: {
    text: 'Thermostat Setpoint',
    align: 'left',
  },
  subtitle: {
    text: "curve: 'stepline' holds each value until the next point",
    align: 'left',
  },
  xaxis: {
    categories: [
      '00:00',
      '02:00',
      '04:00',
      '06:00',
      '08:00',
      '10:00',
      '12:00',
      '14:00',
      '16:00',
      '18:00',
      '20:00',
    ],
  },
  yaxis: {
    labels: {
      formatter: function (val) {
        return val + '°C'
      },
    },
  },
  markers: {
    hover: {
      sizeOffset: 4,
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Stepline Chart in Angular

Using ApexCharts with Angular

This Stepline Chart example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Setpoint',
              data: [16, 16, 18, 21, 21, 19, 19, 22, 22, 18, 16],
            },
          ],
          chart: {
            type: 'line',
            height: 350,
          },
          stroke: {
            curve: 'stepline',
          },
          dataLabels: {
            enabled: false,
          },
          title: {
            text: 'Thermostat Setpoint',
            align: 'left',
          },
          subtitle: {
            text: "curve: 'stepline' holds each value until the next point",
            align: 'left',
          },
          xaxis: {
            categories: [
              '00:00',
              '02:00',
              '04:00',
              '06:00',
              '08:00',
              '10:00',
              '12:00',
              '14:00',
              '16:00',
              '18:00',
              '20:00',
            ],
          },
          yaxis: {
            labels: {
              formatter: (val) => {
                return val + '°C'
              },
            },
          },
          markers: {
            hover: {
              sizeOffset: 4,
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Stepline Chart in Vue

Using ApexCharts with Vue

This Stepline Chart example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="line"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Setpoint',
          data: [16, 16, 18, 21, 21, 19, 19, 22, 22, 18, 16],
        },
      ],
      chartOptions: {
        chart: {
          type: 'line',
          height: 350,
        },
        stroke: {
          curve: 'stepline',
        },
        dataLabels: {
          enabled: false,
        },
        title: {
          text: 'Thermostat Setpoint',
          align: 'left',
        },
        subtitle: {
          text: "curve: 'stepline' holds each value until the next point",
          align: 'left',
        },
        xaxis: {
          categories: [
            '00:00',
            '02:00',
            '04:00',
            '06:00',
            '08:00',
            '10:00',
            '12:00',
            '14:00',
            '16:00',
            '18:00',
            '20:00',
          ],
        },
        yaxis: {
          labels: {
            formatter: function (val) {
              return val + '°C'
            },
          },
        },
        markers: {
          hover: {
            sizeOffset: 4,
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Stepline Chart in React

Using ApexCharts with React

This Stepline Chart example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Setpoint',
        data: [16, 16, 18, 21, 21, 19, 19, 22, 22, 18, 16],
      },
    ],
    options: {
      chart: {
        type: 'line',
        height: 350,
      },
      stroke: {
        curve: 'stepline',
      },
      dataLabels: {
        enabled: false,
      },
      title: {
        text: 'Thermostat Setpoint',
        align: 'left',
      },
      subtitle: {
        text: "curve: 'stepline' holds each value until the next point",
        align: 'left',
      },
      xaxis: {
        categories: [
          '00:00',
          '02:00',
          '04:00',
          '06:00',
          '08:00',
          '10:00',
          '12:00',
          '14:00',
          '16:00',
          '18:00',
          '20:00',
        ],
      },
      yaxis: {
        labels: {
          formatter: function (val) {
            return val + '°C'
          },
        },
      },
      markers: {
        hover: {
          sizeOffset: 4,
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="line"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart